import json

# Any further then this, and the segment teleports
teleport_distance = 1
# At what distance does the segment stay stable
stable_distance = 0.5
# The precision for its detection.
precision = 0.05
# How much force does it use to enforce this limitation.
force_multiplyer = 0.05


def generate_arrayA(max_value, precision):
    array = []
    current_num = 0
    while current_num <= max_value:
        array.append(round(current_num*1000)/1000)
        current_num += precision
    return array

def generate_arrayB(max_value, precision):
    array = []
    current_num = precision
    while current_num <= max_value:
        array.append(round(current_num*1000)/1000)
        current_num += precision
    array.append("Infinity & Beyond")
    return array

def generate_arrayC(max_value, precision,stable_distance,force_multiplyer):
    array = []
    current_distance = precision/2
    while current_distance <= max_value:
        if current_distance > stable_distance:
            array.append(round((-1*current_distance*force_multiplyer)*10000)/10000)
        if current_distance < stable_distance:
            array.append(round((current_distance*force_multiplyer)*10000)/10000)
        if current_distance == stable_distance:
            array.append(0)
        current_distance += precision
    return array

# Sample arrays
array_a = generate_arrayA(teleport_distance,precision)
array_b =generate_arrayB(teleport_distance,precision)
array_c = generate_arrayC(teleport_distance, precision,stable_distance,force_multiplyer)

# Initialize an empty list to store JSON objects
json_objects = []

# Iterate over the arrays and create JSON objects
for i in range(len(array_a)):
    json_obj = {
        "condition": {
            "type": "origins:and",
            "conditions": [
                {
                    "type": "origins:distance",
                    "comparison": ">",
                    "compare_to": array_a[i]
                },
                {
                    "type": "origins:distance",
                    "comparison": "<=",
                    "compare_to": array_b[i]
                }
            ]
        },
        "action": {
            "type": "origins:add_velocity",
            "z": array_c[i],
            "client": True,
            "server": True
        }
    }
    json_objects.append(json_obj)

# Write the JSON objects to a file
with open('gen.json', 'w') as file:
    json.dump(json_objects, file, indent=4)

print("JSON objects have been written to gen.json file.")
